<script setup lang="ts">
import { onMounted, ref } from 'vue'
import MsnApiV1 from '@/api/msnApi'

const subscriberList = ref([])
const perPage = ref<number>(20)
const pageOptions = ref<number[]>([5, 10, 20, 50, 100])
const currentPage = ref<number>(1)
const totalRows = ref<number>(1)

const fields = [
  { key: 'name', title: 'Name' },
  { key: 'subscriber_name', title: 'Full name' },
  { key: 'user_id', title: 'User ID' },
  {
    key: 'created_at',
    title: 'Created',
    formatter: (value: string) => {
      const date = new Date(value)

      return `${date.toLocaleDateString()} ${date.toLocaleTimeString()}`
    },
  },
  { key: 'description', title: 'Description' },
  { key: 'actions', title: 'Actions' },
]

async function getSubscribers() {
  const msnApi = new MsnApiV1()
  try {
    const response = await msnApi.getAllSubscribers(perPage.value, currentPage.value)

    totalRows.value = response.headers['x-total']
    subscriberList.value = response.data.data
  }
  catch (error) {
    console.error('Error fetching subscribers:', error)
  }
}

onMounted(() => {
  getSubscribers()
})
</script>

<template>
  <SettingsTemplate>
    <VRow>
      <VCol
        cols="12"
        class="d-flex justify-end"
      >
        <VBtn
          color="primary"
          :to="{ name: 'settings-subscriber-new' }"
        >
          Add Subscriber
        </VBtn>
      </VCol>
    </VRow>

    <VRow>
      <VCol cols="12">
        <label class="d-inline-block text-sm-left mb-0 mr-50">Show</label>
        <VSelect
          v-model="perPage"
          :items="pageOptions"
          label="Subscribers"
          single-line
          small-chips
        />
      </VCol>
    </VRow>
    <VDataTable
      :headers="fields"
      :items="subscriberList"
      :items-per-page="perPage"
      :current-page="currentPage"
      class="elevation-1"
      loading-text="Loading... Please wait"
      density="compact"
    >
      <template #item.name="{ item }">
        <RouterLink :to="{ name: 'settings-subscriber-edit', params: { id: item.id } }">
          {{ item.name }}
        </RouterLink>
      </template>

      <template #item.user_id="{ item }">
        <RouterLink :to="{ name: 'settings-user-edit', params: { id: item.user_id } }">
          {{ item.user_id }}
        </RouterLink>
      </template>

      <template #item.actions="{ item }">
        <div>
          <SubscriberDeleteModal
            :subscriber-id="item.id"
            :subscriber-name="item.name"
            @finished="getSubscribers"
          />
        </div>
      </template>
    </VDataTable>
    <VRow>
      <VCol cols="12">
        <VPagination
          v-model="currentPage"
          :length="Math.ceil(totalRows / perPage)"
          circle
        />
      </VCol>
    </VRow>
  </SettingsTemplate>
</template>

<style scoped>
tr {
  border-top: 1px solid #ebe9f1;
}
</style>
